/* $Id: makeMx2.c,v 1.3 2003/04/09 13:58:32 roman Exp $ */
/* written by Roman R. Stocsits, 2003 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "utils.h"
#include "structs.h"

extern struct SEQdata *SEQ;
struct ALNdata *aln;

int align();
void encode();
short matrix(int a, int b, int c);
void bluntEnd(int c);
long scoreM(long a, long b, long c, long g, long h);
long scoreIx(long a, long b, long c, long g, long h);
long scoreIy(long a, long b, long c, long g, long h);
void trace(int a, int b, int c, short TRstart);
void write2aln(long c, char **aligns);
struct CLUSTERdata *cluster(long c);
char *translateORF(char *orf, char *CodonTableName);
void pretranslate();
int multiple(struct CLUSTERdata *clust, int c, int a);

/* ----------------------------------------------------------------------- */

void pretranslate(){

  int a=0, b=0;
  long length=0, i, st;
  char *tempseq=NULL;
  
  while(SEQ[a].seq){
    while(SEQ[a].ORF[b].start){
      if(SEQ[a].ORF[b].AAseq == NULL){
	if(SEQ[a].ORF[b].join==0){
	  length=(SEQ[a].ORF[b].stop-SEQ[a].ORF[b].start+1);
	  tempseq=(char*)space((length+1)*sizeof(char));
	  st=SEQ[a].ORF[b].start-1;
	  for(i=0; i<length; i++){
	    tempseq[i]=SEQ[a].seq[st];
	    st++;
	  }
	  tempseq[length]='\0';
	  SEQ[a].ORF[b].AAseq=(char*)space((length/3+1)*sizeof(char));
	  SEQ[a].ORF[b].AAseq=translateORF(tempseq, SEQ[a].CTN);
	  free(tempseq);
	}
	if(SEQ[a].ORF[b].join==3){
	  length=strlen(SEQ[a].ORF[b].joinedSeq);
	  SEQ[a].ORF[b].AAseq=(char*)space((length/3+1)*sizeof(char));
	  SEQ[a].ORF[b].AAseq=translateORF(SEQ[a].ORF[b].joinedSeq, SEQ[a].CTN);
	}
      }
      b++;
    }
    b=0;
    while(SEQ[a].exon[b].start){
      if(SEQ[a].exon[b].AAseq == NULL){
	if(SEQ[a].exon[b].join==3){
	  length=strlen(SEQ[a].exon[b].joinedSeq);
	  SEQ[a].exon[b].AAseq=(char*)space((length/3+1)*sizeof(char));
	  SEQ[a].exon[b].AAseq=translateORF(SEQ[a].exon[b].joinedSeq, SEQ[a].CTN);
	}
      }
      b++;
    }
    a++;
    b=0;
  }
}

/* ----------------------------------------------------------------------- */

void encode(){
  
  int a=0, b, d, x, d1A;
  long npos;
  /* npos ... computational position in joinedSeq */
  fprintf(stdout, "Encoding.....");
  while(SEQ[a].seq){
    SEQ[a].letter=(struct LETTERdata*)space((SEQ[a].len+1)*sizeof(struct LETTERdata));
    for(b=0; b<SEQ[a].len; b++){
      SEQ[a].letter[b].nucl = SEQ[a].seq[b];
      SEQ[a].letter[b].aa[0] = SEQ[a].letter[b].aa[1] = SEQ[a].letter[b].aa[2] =0;

      x=0;
      d=0;
      npos=0;
      
      if(SEQ[a].exon[0].start){
	while(SEQ[a].exon[d].start){
	  if(((b+1) >= SEQ[a].exon[d].start) && ((b+1) <= SEQ[a].exon[d].stop)){
	    if(SEQ[a].exon[d].join == 1){
	      npos = b+1-SEQ[a].exon[d].start;
	    }
	    else if(SEQ[a].exon[d].join > 1){
	      while(x < d){
		npos = npos + (SEQ[a].exon[x].stop - SEQ[a].exon[x].start +1);
		x++;
	      }
	      npos = npos + b+1-SEQ[a].exon[d].start;
	    }
	    d1A=d;
	    while(SEQ[a].exon[d1A].join < 3)     d1A++;
	    if(npos%3 == 0)   SEQ[a].letter[b].aa[0] = SEQ[a].exon[d1A].AAseq[npos/3];
	    if(npos%3 == 1)   SEQ[a].letter[b].aa[1] = SEQ[a].exon[d1A].AAseq[npos/3];
	    if(npos%3 == 2)   SEQ[a].letter[b].aa[2] = SEQ[a].exon[d1A].AAseq[npos/3];
	    break;
	  }
	  x=0;
	  d++;
	}
      }
      
      else{
	if(SEQ[a].ORF[0].start){
	  while(SEQ[a].ORF[d].start){
	    if(((b+1) >= SEQ[a].ORF[d].start) && ((b+1) <= SEQ[a].ORF[d].stop)){
	      if((SEQ[a].ORF[d].join == 1) || (SEQ[a].ORF[d].join == 0)){
		npos = b+1-SEQ[a].ORF[d].start;
	      }
	      else if(SEQ[a].ORF[d].join > 1){
		x=d-1;
		while(SEQ[a].ORF[x].join > 1){
		  npos = npos + (SEQ[a].ORF[x].stop - SEQ[a].ORF[x].start +1);
		  x--;
		}
		npos = npos + (SEQ[a].ORF[x].stop - SEQ[a].ORF[x].start +1);
		npos = npos + b+1-SEQ[a].ORF[d].start;
	      }
	      d1A=d;
	      if(SEQ[a].ORF[d1A].join){
		while(SEQ[a].ORF[d1A].join < 3)     d1A++;
	      }
	      if(npos%3 == 0)   SEQ[a].letter[b].aa[0] = SEQ[a].ORF[d1A].AAseq[npos/3];
	      if(npos%3 == 1)   SEQ[a].letter[b].aa[1] = SEQ[a].ORF[d1A].AAseq[npos/3];
	      if(npos%3 == 2)   SEQ[a].letter[b].aa[2] = SEQ[a].ORF[d1A].AAseq[npos/3];
	      break;
	    }
	    x=0;
	    d++;
	  }
	}
	
	else if(SEQ[a].found[0].start){
	  while(SEQ[a].found[d].start){
	    if(((b+1) >= SEQ[a].found[d].start) && ((b+1) <= SEQ[a].found[d].stop)){
	      npos = b+1-SEQ[a].found[d].start;
	      if(npos%3 == 0)   SEQ[a].letter[b].aa[0] = SEQ[a].found[d].AAseq[npos/3];
	      if(npos%3 == 1)   SEQ[a].letter[b].aa[1] = SEQ[a].found[d].AAseq[npos/3];
	      if(npos%3 == 2)   SEQ[a].letter[b].aa[2] = SEQ[a].found[d].AAseq[npos/3];
	      break;
	    }
	    d++;
	  }
	}
      }
    }
    SEQ[a].letter[b].nucl = 0;
    a++;
  }
  fprintf(stdout, "Done\n");  
}

/* ----------------------------------------------------------------------- */

int align(){

  int c=0, a=0, b=1, z, d;
  struct CLUSTERdata *clust;
  short TRstart;

  fprintf(stdout, "Pairwise alignments.....\n");
  while(SEQ[a].seq){
    while(SEQ[b].seq){
      c++;
      b++;
    }
    a++;
    b=a+1;
  }
  aln=(struct ALNdata*)space(c*sizeof(struct ALNdata));
  c=0;
  a=0;
  b=1;
  while(SEQ[a].seq){
    while(SEQ[b].seq){
      TRstart = matrix(a, b, c);
      fprintf(stdout, "Alignment: %i   Sequ. (%i : %i)   Score: %li\n", c+1, a+1, b+1, aln[c].score);
      z = SEQ[a].len + SEQ[b].len +1;
      aln[c].alignment = (struct LETTERdata**)space(3*sizeof(struct LETTERdata*));
      aln[c].alignment[0] = (struct LETTERdata*)space(z*sizeof(struct LETTERdata));
      aln[c].alignment[1] = (struct LETTERdata*)space(z*sizeof(struct LETTERdata));
      aln[c].alignment[2] = NULL;
      trace(a, b, c, TRstart);
      b++;
      c++;
    }
    a++;
    b=a+1;
  }
  clust=cluster(c);
  fprintf(stdout, "Profile alignments.....\n");
  d = multiple(clust, c, a);
  return(d);
}

/* ----------------------------------------------------------------------- */

short matrix(int a, int b, int c){

  short TRstart=0;
  int h=0, f=0, g;
  
  for(h=0; h<200; h++)   aln[c].no[h]=0;
  aln[c].no[0]=a+1;
  aln[c].no[1]=b+1;
  aln[c].seqname = (char**)space(3*sizeof(char*));
  aln[c].seqname[0]= (char*)space(256*sizeof(char));
  aln[c].seqname[1]= (char*)space(256*sizeof(char));
  aln[c].seqname[0] = SEQ[a].seqname;
  aln[c].seqname[1] = SEQ[b].seqname;
  aln[c].seqname[2] = NULL;
  aln[c].SCmatrix = (int***)space(3*sizeof(int**));
  aln[c].TRmatrix=(char***)space(3*sizeof(char**));
  for(h=0; h<3; h++)    aln[c].TRmatrix[h] = (char**)space((SEQ[b].len)*sizeof(char*));
  for(h=0; h<3; h++)    aln[c].SCmatrix[h]=(int**)space((SEQ[b].len+1)*sizeof(int*));
  for(h=0; h<3; h++)    aln[c].SCmatrix[h][0]=(int*)space((SEQ[a].len+1)*sizeof(int));
  for(h=0; h < (SEQ[a].len+1); h++){
    aln[c].SCmatrix[0][0][h]=f;
    aln[c].SCmatrix[1][0][h]=f;
    aln[c].SCmatrix[2][0][h]=f;
    f=f-1;
  }
  f=-1;
  for(g=1; g < (SEQ[b].len+1); g++){
    for(h=0; h<3; h++){
      aln[c].SCmatrix[h][g]=(int*)space((SEQ[a].len+1)*sizeof(int));
      aln[c].TRmatrix[h][g-1]=(char*)space((SEQ[a].len+1)*sizeof(char));
      aln[c].SCmatrix[h][g][0]=f;
    }
    f=f-1;
    for(h=1; h < (SEQ[a].len+1); h++){
      aln[c].SCmatrix[0][g][h] = scoreM(a, b, c, g, h);
      aln[c].SCmatrix[1][g][h] = scoreIx(a, b, c, g, h);
      aln[c].SCmatrix[2][g][h] = scoreIy(a, b, c, g, h);
    }
    free(aln[c].SCmatrix[0][g-1]);
    free(aln[c].SCmatrix[1][g-1]);
    free(aln[c].SCmatrix[2][g-1]);
  }
  g=g-1;
  h=h-1;
  if((aln[c].SCmatrix[0][g][h] >= aln[c].SCmatrix[1][g][h]) &&
     (aln[c].SCmatrix[0][g][h] >= aln[c].SCmatrix[2][g][h])){
    aln[c].score = aln[c].SCmatrix[0][g][h];
    TRstart = 0;
  }
  if((aln[c].SCmatrix[1][g][h] >= aln[c].SCmatrix[2][g][h]) &&
     (aln[c].SCmatrix[1][g][h] > aln[c].SCmatrix[0][g][h])){
    aln[c].score = aln[c].SCmatrix[1][g][h];
    TRstart = 1;
  }
  if((aln[c].SCmatrix[2][g][h] > aln[c].SCmatrix[1][g][h]) &&
     (aln[c].SCmatrix[2][g][h] > aln[c].SCmatrix[0][g][h])){
    aln[c].score = aln[c].SCmatrix[2][g][h];
    TRstart = 2;
  }
  free(aln[c].SCmatrix[0][g]);
  free(aln[c].SCmatrix[1][g]);
  free(aln[c].SCmatrix[2][g]);
  free(aln[c].SCmatrix[0]);
  free(aln[c].SCmatrix[1]);
  free(aln[c].SCmatrix[2]);
  free(aln[c].SCmatrix);
  return(TRstart);
}

/* ----------------------------------------------------------------------- */

void trace(int a, int b, int c, short TRstart){
  
  int x, y, z, i, j, r=1, s=1;
  short d;
  struct LETTERdata empty;
 
  empty.nucl = '-';
  for(i=0; i<3; i++){
    empty.aa[i] = 0;
  }
  x=SEQ[a].len;
  y=SEQ[b].len;
  z=x+y+1;
  d = TRstart;
  
  for(i=0; i<z; i++){
    aln[c].alignment[0][i].nucl = '-';
    aln[c].alignment[1][i].nucl = '-';
    for(j=0; j<3; j++){
      aln[c].alignment[0][i].aa[j] = 0;
      aln[c].alignment[1][i].aa[j] = 0;
    }
  }
  z--;
  aln[c].alignment[0][z].nucl = 0;
  aln[c].alignment[1][z].nucl = 0;
  z--;
  x--;
  y--;

  while(x || y || r || s){
    if(d==0){
      if(r)   aln[c].alignment[0][z] = SEQ[a].letter[x];
      if(s)   aln[c].alignment[1][z] = SEQ[b].letter[y];
      switch(aln[c].TRmatrix[d][y][x]){
      case '1':     d=0;	break;
      case '2':     d=1;	break;
      case '3':     d=2;	break;
      default: fprintf(stderr, "Fatal error 1 in traceback!\n");  exit(1);
      }
      z--;
      if(x)  x--;
      else  r=0;
      if(y)  y--;
      else s=0;
      continue;
    }
    if(d==1){
      if(r)   aln[c].alignment[0][z] = SEQ[a].letter[x];
      aln[c].alignment[1][z] = empty;
      switch(aln[c].TRmatrix[d][y][x]){
      case '1':     d=0;	break;
      case '2':     d=1; 	break;
      case '3':     d=2;	break;
      default: fprintf(stdout, "Fatal error 2 in traceback!\n");  exit(2);
      }
      z--;
      if(x) x--;
      else r=0;
      if(!x && !y && !r && s)  d=2;
      continue;
    }
    if(d==2){
      aln[c].alignment[0][z] = empty;
      if(s)   aln[c].alignment[1][z] = SEQ[b].letter[y];
      switch(aln[c].TRmatrix[d][y][x]){
      case '1':     d=0;	break;
      case '2':     d=1; 	break;
      case '3':     d=2;	break;
      default: fprintf(stdout, "Fatal error 3 in traceback!\n");  exit(3);
      }
      z--;
      if(y)   y--;
      else   s=0;
      if(!x && !y && !s && r)  d=1;
      continue;
    }
  }
  for(x=0; x<3; x++){
    for(y=0; y<SEQ[b].len; y++){
      free(aln[c].TRmatrix[x][y]);
    }
    free(aln[c].TRmatrix[x]);
  }
  free(aln[c].TRmatrix);
  bluntEnd(c);
}
