/* $Id: multiple3.c,v 1.3 2003/04/09 13:58:32 roman Exp $ */
/* written by Roman R. Stocsits, 2003 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "utils.h"
#include "structs.h"

extern struct SEQdata *SEQ;
extern struct ALNdata *aln;

struct CLUSTERdata *cluster(int c);
int multiple(struct CLUSTERdata *clust, int c, int a);
void findPartn(int c, struct CLUSTERdata clust);
short multMx(struct ALNdata tempaln[2], int c);
void bluntEnd(int c);
void output();
void check();
void multTrace(struct ALNdata tempaln[2], int c, short TRstart);
int MscoreM(struct ALNdata tempaln[2], int c, int g, int h);
int MscoreIx(struct ALNdata tempaln[2], int c, int g, int h);
int MscoreIy(struct ALNdata tempaln[2], int c, int g, int h);

/* -------------------------------------------------------------------- */

struct CLUSTERdata *cluster(int c){
  
  int a=0, b=0, g, d=0, e=0, i, temp_b=0, temp_g=0, x=0, y=0, m, n, z;
  struct CLUSTERdata *clust;
  long HighScore= -1000000, allscore=0;
  float scoreCL;
  FILE *fp;
  
  while(SEQ[a].seq)  a++;
  clust=(struct CLUSTERdata*)space(((2*a)+1)*sizeof(struct CLUSTERdata));
  a=0;
  while(SEQ[a].seq){
    clust[a].no[0]=SEQ[a].no;
    clust[a].done=0;
    for(i=1; i<200; i++)  clust[a].no[i]=0;
    for(i=0; i<200; i++){
      clust[a].melted1[i]=0;
      clust[a].melted2[i]=0;
    }
    a++;
  }
  for(i=0; i<200; i++){
    clust[a].no[i]=0;
    clust[a+1].no[i]=0;
    clust[a].melted1[i]=0;
    clust[a].melted2[i]=0;
  }
  
  z=2*a-1;
  while(a<z){
    
    for(b=0; b<(a-1); b++){
      if(clust[b].done) continue;
      for(g=b+1; g<a; g++){
	if(clust[g].done) continue;
	
	while(clust[b].no[d]){
	  while(clust[g].no[e]){
	    for(i=0; i<c; i++){
	      if(((aln[i].no[0]==clust[b].no[d]) && 
		  (aln[i].no[1]==clust[g].no[e])) || 
		 ((aln[i].no[1]==clust[b].no[d]) && 
		  (aln[i].no[0]==clust[g].no[e]))){
		allscore=allscore+aln[i].score;
   		x++;
		break;
	      }
	    }
	    e++;
	  }
	  e=0;
	  d++;
	}
	
	scoreCL= (float)allscore/(float)x;
	if(scoreCL>(float)(HighScore)){
	  HighScore=scoreCL;
	  temp_b=b;
	  temp_g=g;
	}
	x=0;
	allscore=0;
	d=0;
      }
    }
    clust[temp_b].done=1;
    clust[temp_g].done=1;
    x=0;
    y=0;
    while(clust[temp_b].no[x]){
      clust[a].no[y]=clust[temp_b].no[x];
      clust[a].melted1[x]=clust[temp_b].no[x];
      x++;
      y++;
    }
    x=0;
    while(clust[temp_g].no[x]){
      clust[a].no[y]=clust[temp_g].no[x];
      clust[a].melted2[x]=clust[temp_g].no[x];
      x++;
      y++;
    }
    HighScore=-100000;
    a++;
  }
  
  m=0;
  n=0;
  fp=fopen("cluster.txt", "w");
  while(clust[m].no[0]){
    fprintf(fp, "Cluster: %i   Sequence(s): ", m);
    while(clust[m].no[n]){
      fprintf(fp, "%i", clust[m].no[n]);
      n++;
      if(clust[m].no[n])   fprintf(fp, ", ");
    }
    fprintf(fp, "\n");
    n=0;
    m++;
  }
  fclose(fp);
  return(clust);
}

/* ---------------------------------------------------------------- */

int multiple(struct CLUSTERdata *clust, int c, int a){
 
  /* c=no of pair aligns, a=no of SEQs */
  int i, m, n, d;
  
  d=c;
  aln=(struct ALNdata*)realloc(aln, (c+a)*sizeof(struct ALNdata));
  for(m=c; m<(c+a); m++){
    for(n=0; n<200; n++)   aln[m].no[n] = 0;
  }
  m=a;
  n=0;
  while(clust[m].no[0]){
    while(clust[m].no[n]){
      n++;
    }
    if(n==2){
      for(i=0; i<d; i++){
	if(((aln[i].no[0]==clust[m].no[0]) && 
	    (aln[i].no[1]==clust[m].no[1])) || 
	   ((aln[i].no[1]==clust[m].no[0]) && 
	    (aln[i].no[0]==clust[m].no[1]))){

	  aln[c] = aln[i];
	  break;
	}
      }
    }
    else    findPartn(c, clust[m]);
    fprintf(stdout, "Alignment: %i   Cluster: %i   Score: %li\n",
		  c+1, m, aln[c].score);
    c++;
    n=0;
    m++;
  }
  return(c);
}

/* -------------------------------------------------------------------- */

void findPartn(int c, struct CLUSTERdata clust){
  
  /* c=current aln */
  
  int d=0, h1=0, h2=0, i=0, q=0, e=0;
  struct ALNdata tempaln[2];
  short TRstart=0;
  
  while(clust.melted1[d]) d++;
  if(d==1){
    while(SEQ[h1].seq){
      if(SEQ[h1].no == clust.melted1[0])   break;
      else h1++;
    }
    tempaln[0].alignment = (struct LETTERdata**)space
      (2*sizeof(struct LETTERdata*));
    tempaln[0].seqname = (char**)space(2*sizeof(char*));
    tempaln[0].seqname[0] = (char*)space(256*sizeof(char));
    q=0;
    tempaln[0].alignment[0] = SEQ[h1].letter;
    strcpy(tempaln[0].seqname[0], SEQ[h1].seqname);
    free(SEQ[h1].seqname);
    tempaln[0].alignment[1] = NULL;
    tempaln[0].seqname[1] = NULL;
    tempaln[0].no[0] = SEQ[h1].no;
    tempaln[0].no[1] = 0;
  }
  else{
    if(d==0){
      fprintf(stderr, "Fatal error. Aborting.\n");
      exit(90);
    }
    h1=0;
    for(i=0; i<c; i++){
      while(clust.melted1[h1] || aln[i].no[h1]){
	if(clust.melted1[h1] == aln[i].no[h1]){
	  h1++;
	}
	else{
	  h1=0;
	  break;
	}
      }
      if(h1){
	q=0;
	e=0;
	while(aln[i].alignment[q])      q++;
	while(aln[i].alignment[0][e].nucl)    e++;

	tempaln[0] = aln[i];
	tempaln[0].alignment[q] = NULL;
	tempaln[0].seqname[q] = NULL;
	tempaln[0].no[q] = 0;
	
	break;
      }
    }
  }
  d=0;
  while(clust.melted2[d])    d++;
  if(d==1){
    while(SEQ[h2].seq){
      if(SEQ[h2].no == clust.melted2[0]) break;
      else h2++;
    }
    tempaln[1].alignment = (struct LETTERdata**)space
      (2*sizeof(struct LETTERdata*));
    tempaln[1].seqname = (char**)space(2*sizeof(char*));
    tempaln[1].alignment[0] = SEQ[h2].letter;
    tempaln[1].alignment[1] = NULL;
    tempaln[1].seqname[0] = (char*)space(256*sizeof(char));
    strcpy(tempaln[1].seqname[0], SEQ[h2].seqname);
    tempaln[1].seqname[1] = NULL;
    tempaln[1].no[0] = SEQ[h2].no;
    tempaln[1].no[1] = 0;
  }
  else{
    if(d==0){
      fprintf(stderr, "Fatal error. Aborting.\n");
      exit(91);
    }
    h2=0;
    for(i=0; i<c; i++){
      while(clust.melted2[h2] || aln[i].no[h2]){
	if(clust.melted2[h2] == aln[i].no[h2]){
	  h2++;
	}
	else{
	  h2=0;
	  break;
	}
      }
      if(h2){
	q=0;
	e=0;
	while(aln[i].alignment[q])      q++;
	while(aln[i].alignment[0][e].nucl)    e++;
	
	tempaln[1] = aln[i];
	tempaln[1].alignment[q] = NULL;
	tempaln[1].seqname[q] = NULL;
	tempaln[1].no[q] = 0;
	
	break;
      }
    }
  }
  TRstart = multMx(tempaln, c);
  multTrace(tempaln, c, TRstart);
}

/* ------------------------------------------------------------------- */

short multMx(struct ALNdata tempaln[2], int c){
  
  int a=0, b=0, f=0, g, h;
  short TRstart=0;
  
  while(tempaln[0].alignment[0][a].nucl){
    a++;
  }
  while(tempaln[1].alignment[0][b].nucl){
    b++;
  }
  /*  a horizontal, b vertikal  */
  aln[c].SCmatrix = (int***)space(3*sizeof(int**));
  aln[c].TRmatrix=(char***)space(3*sizeof(char**));
  for(h=0; h<3; h++)   aln[c].TRmatrix[h]=(char**)space(b*sizeof(char*));
  for(h=0; h<3; h++)   aln[c].SCmatrix[h]=(int**)space((b+1)*sizeof(int*));
  for(h=0; h<3; h++)   aln[c].SCmatrix[h][0]=(int*)space((a+1)*sizeof(int));
  for(h=0; h<(a+1); h++){
    aln[c].SCmatrix[0][0][h]=f;
    aln[c].SCmatrix[1][0][h]=f;
    aln[c].SCmatrix[2][0][h]=f;
    f=f-1;
  }
  f=-1;
  for(g=1; g<(b+1); g++){
    for(h=0; h<3; h++){
      aln[c].SCmatrix[h][g]=(int*)space((a+1)*sizeof(int));
      aln[c].TRmatrix[h][g-1]=(char*)space((a+1)*sizeof(char));
      aln[c].SCmatrix[h][g][0]=f;
    }
    f=f-1;
    for(h=1; h<(a+1); h++){
      aln[c].SCmatrix[0][g][h] = MscoreM(tempaln, c, g, h);
      aln[c].SCmatrix[1][g][h] = MscoreIx(tempaln, c, g, h);
      aln[c].SCmatrix[2][g][h] = MscoreIy(tempaln, c, g, h);
    }
    free(aln[c].SCmatrix[0][g-1]);
    free(aln[c].SCmatrix[1][g-1]);
    free(aln[c].SCmatrix[2][g-1]);
  }
  if(((aln[c].SCmatrix[0][b][a]) >= (aln[c].SCmatrix[1][b][a])) &&
     ((aln[c].SCmatrix[0][b][a]) >= (aln[c].SCmatrix[2][b][a]))){
    aln[c].score = aln[c].SCmatrix[0][b][a];
    TRstart = 0;
  }
  else if(((aln[c].SCmatrix[1][b][a]) > (aln[c].SCmatrix[0][b][a])) &&
	  ((aln[c].SCmatrix[1][b][a]) >= (aln[c].SCmatrix[2][b][a]))){
    aln[c].score = aln[c].SCmatrix[1][b][a];
    TRstart = 1;
  }
  else if(((aln[c].SCmatrix[2][b][a]) > (aln[c].SCmatrix[0][b][a])) &&
	  ((aln[c].SCmatrix[2][b][a]) > (aln[c].SCmatrix[1][b][a]))){
    aln[c].score = aln[c].SCmatrix[2][b][a];
    TRstart = 2;
  }
  free(aln[c].SCmatrix[0][b]);
  free(aln[c].SCmatrix[1][b]);
  free(aln[c].SCmatrix[2][b]);
  free(aln[c].SCmatrix[0]);
  free(aln[c].SCmatrix[1]);
  free(aln[c].SCmatrix[2]);
  free(aln[c].SCmatrix);
  return(TRstart);
}

/* ------------------------------------------------------------------- */

void multTrace(struct ALNdata tempaln[2], int c, short TRstart){
  
  int x=0, y=0, z, h, n=0;
  short d, r=1, s=1, j, i;
  int a=0, b=0, e, f, q=0, p=0;
  struct LETTERdata empty;

  empty.nucl = '-';
  for(i=0; i<3; i++){
    empty.aa[i] = 0;
  }
  while(tempaln[0].alignment[a])             a++;
  while(tempaln[1].alignment[b])             b++;
  while(tempaln[0].alignment[0][x].nucl)     x++;
  while(tempaln[1].alignment[0][y].nucl)     y++;
  z=x+y;
  d=TRstart;
  aln[c].alignment=(struct LETTERdata**)space
    ((a+b+1)*sizeof(struct LETTERdata*));
  aln[c].seqname=(char**)space((a+b+1)*sizeof(char*));
  for(e=0; e<(a+b); e++){
    aln[c].alignment[e]=(struct LETTERdata*)space
      ((z+1)*sizeof(struct LETTERdata));
    aln[c].seqname[e]=(char*)space(256*sizeof(char));
    for(h=0; h<z; h++){
      aln[c].alignment[e][h].nucl = '-';
      for(j=0; j<3; j++){
	aln[c].alignment[e][h].aa[j] = 0;
      }
    }
    aln[c].alignment[e][z].nucl = 0;
  }
  aln[c].alignment[a+b]=NULL;
  aln[c].seqname[a+b]=NULL;
  e=0;
  f=0;
  while(tempaln[0].no[e]){
    aln[c].no[f] = tempaln[0].no[e];
    strcpy(aln[c].seqname[f], tempaln[0].seqname[e]);
    e++;
    f++;
  }
  e=0;
  while(tempaln[1].no[e]){
    aln[c].no[f] = tempaln[1].no[e];
    strcpy(aln[c].seqname[f], tempaln[1].seqname[e]);
    e++;
    f++;
  }
  aln[c].seqname[f] = NULL;
  aln[c].no[f] = 0;
  z--;
  x--;
  y--;
  n=y;
  while(x || y || r || s){
    if(d==0){
      if(r){
	while(tempaln[0].alignment[q]){
	  aln[c].alignment[p][z] = tempaln[0].alignment[q][x];
	  p++;
	  q++;
	}
      }
      else {
	while(tempaln[0].alignment[q]){
	  q++;
	  p++;
	}
      }
      q=0;
      if(s){
	while(tempaln[1].alignment[q]){
	  aln[c].alignment[p][z] = tempaln[1].alignment[q][y];
	  p++;
	  q++;
	}
      }
      switch(aln[c].TRmatrix[d][y][x]){
      case '1': 	d=0;    	break;
      case '2': 	d=1;    	break;
      case '3': 	d=2;    	break;
      default: fprintf(stderr, "Fatal error 1!\n");  exit(1);
      }
      z--;
      if(x)  x--;
      else  r=0;
      if(y)  y--;
      else  s=0;
      q=0;
      p=0;
      continue;
    }
    
    if(d==1){
      if(r){
	while(tempaln[0].alignment[q]){
	  aln[c].alignment[p][z] = tempaln[0].alignment[q][x];
	  p++;
	  q++;
	}
      }
      else {
	while(tempaln[0].alignment[q]){
	  q++;
	  p++;
	}
      }
      q=0;
      while(tempaln[1].alignment[q]){
	aln[c].alignment[p][z] = empty;
	p++;
	q++;
      }
      switch(aln[c].TRmatrix[d][y][x]){
      case '1': 	d=0;    	break;
      case '2': 	d=1;    	break;
      case '3': 	d=2;    	break;
      default: fprintf(stderr, "Fatal error 2!\n");  
	exit(2); 
      }
      z--;
      if(x)  x--;
      else  r=0;
      if(!x && !y && !r && s)  d=2;
      q=0;
      p=0;
      continue;
    }
    
    if(d==2){
      while(tempaln[0].alignment[q]){
	aln[c].alignment[p][z] = empty;
	p++;
	q++;
      }
      q=0;
      if(s){
	while(tempaln[1].alignment[q]){
	  aln[c].alignment[p][z] = tempaln[1].alignment[q][y];
	  p++;
	  q++;
	}
      }
      switch(aln[c].TRmatrix[d][y][x]){
      case '1': 	d=0;    	break;
      case '2': 	d=1;    	break;
      case '3': 	d=2;    	break;
      default: fprintf(stderr, "Fatal error 3!\n");  exit(3);
      }
      z--;
      if(y)  y--;
      else   s=0;
      if(!x && !y && !s && r)  d=1;
      q=0;
      p=0;
      continue;
    }
  }
  
  for(a=0; a<3; a++){
    for(b=0; b<(n); b++){
      free(aln[c].TRmatrix[a][b]);
    }
    free(aln[c].TRmatrix[a]);
  }
  free(aln[c].TRmatrix);
  
  bluntEnd(c);
}

/* ------------------------------------------------------------------- */

void bluntEnd(int c){

  int a=0, b=0, min=1000000, d=0, e;
  struct LETTERdata *temp;
  
  while(aln[c].alignment[a]){
    while(aln[c].alignment[a][b].nucl){
      if(aln[c].alignment[a][b].nucl == '-')      b++;
      else break;
    }
    if(b<min) min=b;
    a++;
    b=0;
  }
  
  while(aln[c].alignment[0][d].nucl)       d++;
  a=0;
  b=0;
  e=min;
  
  while(aln[c].alignment[a]){
    temp=(struct LETTERdata*)space((d-min+1)*sizeof(struct LETTERdata));
    while(aln[c].alignment[a][e].nucl){
      temp[b] = aln[c].alignment[a][e];
      b++;
      e++;
    }
    temp[b].nucl = 0;
    free(aln[c].alignment[a]);
    aln[c].alignment[a]=(struct LETTERdata*)space((d-min+1)*sizeof(struct LETTERdata));
    b=0;
    while(temp[b].nucl){
      aln[c].alignment[a][b] = temp[b];
      b++;
    }
    aln[c].alignment[a][b].nucl = 0;
    free(temp);
    b=0;
    e=min;
    a++;
  }
}

/* ------------------------------------------------------------------- */

void output(int c){

  FILE *result;
  int b=0, r=0, s=0, t, u=0, i;
  char *date;
  
  c--;  
  date=time_stamp();
  result = fopen("aln.aln", "w");
  while(aln[c].alignment[0][r].nucl)     r++;
  s = r%60;
  r = r/60;
  fprintf(result,"CLUSTAL W style - code2aln alignment     %s\n\n", date);
  for(t=0; t<r; t++){
    while(aln[c].seqname[b]){
      fprintf(result, "%-15s ", aln[c].seqname[b]);
      for(i=u; i<u+60; i++){
	fprintf(result,"%c",aln[c].alignment[b][i].nucl);
      }
      fprintf(result,"\n");
      b++;
    }
    fprintf(result,"  \n\n");
    b=0;
    u+=60;
  }
  if(s){
    while(aln[c].seqname[b]){
      fprintf(result, "%-15s ", aln[c].seqname[b]);
      for(i=u; i<u+s; i++){
	fprintf(result, "%c", aln[c].alignment[b][i].nucl);
      }
      fprintf(result,"\n");
      b++;
    }
  }
  fprintf(result,"  \n");
  fclose(result);
}

/* ------------------------------------------------------------------- */

void check(){

  int a=0, b=0, c=0, d=0, e, f=0;
  char *testseq;
  
  while(aln[a].no[0]){
    a++;
  }
  a=a-1;
  while(aln[a].alignment[0][d].nucl)    d++; 
  while(aln[a].no[b]){
    testseq = (char*)space((d+1)*sizeof(char));
    for(e=0; e<d; e++){
      if(isalpha(aln[a].alignment[b][e].nucl)){
	testseq[f] = aln[a].alignment[b][e].nucl;
	f++;
      }
    }
    testseq[f] = '\0';
    while(SEQ[c].seq){
      if(aln[a].no[b] == SEQ[c].no){
	if(strcmp(testseq, SEQ[c].seq)){
	  fprintf(stdout, "BAD ALIGNMENT ERROR! SEQ no %i\n", c);
	  exit(27);
	}
	else break;
      }
      else c++;
    }
    free(testseq);
    b++;
    c=0;
    f=0;
  }
}


