/* $Id: readGBF.c,v 1.1.1.1 2003/03/14 15:20:17 roman Exp $ */
/* written by Roman R. Stocsits, 2003 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "utils.h"
#include "structs.h"

extern struct SEQdata *SEQ;

short readGBF(char FN[256], char CTN[8], char *line, FILE *fp, short is_fp);
char *get_seq(FILE *fp, char *line, long len, short is_fp);
short write2SEQ1(char FN[256], char CTN[8], char seqname[256],
		 char *seq, long len, struct CDSdata* ORF,
		 struct CDSdata *exon);
char *readAAseq(char *line, FILE *fp, short is_fp);
char *translateORF(char *orf, char *CodonTableName);
void mergeJOIN();
void help(short ret);

/*--------------------------------------------------------------------------*/

short readGBF(char FN[256], char CTN[8], char *line, FILE *fp, short is_fp){ 

  short read=0, ok=0, q=0, w=0, b, ex=0;
  char *seq, seqname[256], *line2;
  long len;
  int aa;
  struct CDSdata *ORF=NULL;
  struct CDSdata *exon=NULL;

  while(line){
    if(!strncmp(line,"     exon",9)){
      ex=1;
      break;
    }
    if(!strncmp(line,"FT   exon",9)){
      ex=1;
      break;
    }
    else {
      free(line);
      line=get_line(fp);
      continue;
    }
  }

  rewind(fp);
  line=get_line(fp);
  while(line){
    if(read){
      seq=get_seq(fp, line, len, is_fp);
      read=0;
    }
    else {
      if(!strncmp(line, "ID", 2)){
	sscanf(line, "%*s %s", seqname);
	ORF=(struct CDSdata*)space(120*sizeof(struct CDSdata));
	for(q=0; q<120; q++){
	  ORF[q].join=0;
	  ORF[q].start=0;
	  ORF[q].stop=0;
	  ORF[q].AAseq=NULL;
	  ORF[q].joinedSeq=NULL;
	}
	exon=(struct CDSdata*)space(120*sizeof(struct CDSdata));
	for(q=0; q<120; q++){
	  exon[q].join=0;
	  exon[q].start=0;
	  exon[q].stop=0;
	  exon[q].AAseq=NULL;
	  exon[q].joinedSeq=NULL;
	}
	q=0;
	free(line);
	line=get_line(fp);
	continue;
      }
      if(strncmp(line, "FT   source", 11)==0){
	sscanf(line, "%*s %*s %*[1] %*[ .] %li", &len);
	free(line);
	line=get_line(fp);
	continue;
      }
      if((strncmp(line,"ORIGIN", 6)==0)||
	 (strncmp(line, "SQ", 2)==0)){
	read=1;
	free(line);
	line=get_line(fp); 
	continue;
      }
      if(strncmp(line,"LOCUS",5)==0){	  
	sscanf(line,"%*s %s %li", seqname, &len);
	ORF=(struct CDSdata*)space(120*sizeof(struct CDSdata));
	for(q=0; q<120; q++){
	  ORF[q].join=0;
	  ORF[q].start=0;
	  ORF[q].stop=0;
	  ORF[q].AAseq=NULL;
	  ORF[q].joinedSeq=NULL;
	}
	exon=(struct CDSdata*)space(120*sizeof(struct CDSdata));
	for(q=0; q<120; q++){
	  exon[q].join=0;
	  exon[q].start=0;
	  exon[q].stop=0;
	  exon[q].AAseq=NULL;
	  exon[q].joinedSeq=NULL;
	}
	q=0;
	free(line);
	line=get_line(fp);
	continue;
      }
      if((strncmp(line,"                     /translation=",34)==0)||
	 (strncmp(line,"FT                   /translation=",34)==0)){
 	if(!ex){
 	  ORF[q-1].AAseq=(char*)space(((60000)+1)*sizeof(char));
	  strcpy(ORF[q-1].AAseq, readAAseq(line, fp, is_fp));
	}
 	else if(ex){
  	  exon[0].AAseq=(char*)space(((60000)+1)*sizeof(char));
  	  strcpy(exon[0].AAseq, readAAseq(line, fp, is_fp));
	}  
      }
      if((!strncmp(line,"FT   CDS             join",25))||
	 (!strncmp(line,"     CDS             join",25))){
	line2=(char*)space(10000*sizeof(char));
	strcpy(line2, line);
	while(!strchr(line, ')')){
	  free(line);
	  line=get_line(fp);
	  strcat(line2, line);
	}
	b=q;
	sscanf(line2,"%*[FT ] %*[CDS ] %*[join( ] %li %*[. ] %li %*[, ] %li %*[. ] %li %*[, ] %li %*[. ] %li %*[, ] %li %*[. ] %li %*[, ] %li %*[. ] %li %*[, ] %li %*[. ] %li %*[, ] %li %*[. ] %li %*[, ] %li %*[. ] %li %*[, ] %li %*[. ] %li %*[, ] %li %*[. ] %li %*[, ] %li %*[. ] %li %*[, ] %li %*[. ] %li",
	       &ORF[q].start, &ORF[q].stop, &ORF[q+1].start, &ORF[q+1].stop,
	       &ORF[q+2].start, &ORF[q+2].stop, &ORF[q+3].start, &ORF[q+3].stop,
	       &ORF[q+4].start, &ORF[q+4].stop, &ORF[q+5].start, &ORF[q+5].stop,
	       &ORF[q+6].start, &ORF[q+6].stop, &ORF[q+7].start, &ORF[q+7].stop,
	       &ORF[q+8].start, &ORF[q+8].stop, &ORF[q+9].start, &ORF[q+9].stop,
	       &ORF[q+10].start, &ORF[q+10].stop, &ORF[q+11].start, &ORF[q+11].stop);
	q+=12;
	while(ORF[q].start==0) q-=1;
	ORF[b].join=1;
	b++;
	while(ORF[b+1].start){
	  ORF[b].join=2;
	  b++;
	}
	ORF[b].join=3;
	q++;
	free(line);
	line=get_line(fp);
	continue;
      }
      if(!strncmp(line,"     CDS",8)){
	if(!strchr(line,'j')){
	  if(strchr(line,'<')){
	    sscanf(line,"%*s %*[<] %li %*[ .>] %li",
		   &ORF[q].start, &ORF[q].stop);
	  }
	  else{
	    sscanf(line,"%*s %li %*[ .>] %li",
		   &ORF[q].start, &ORF[q].stop);
	  }
	  q++;
      	}
	free(line);
	line=get_line(fp);
	continue;
      }
      if(!strncmp(line,"FT   CDS",8)){
	if(!strchr(line,'j')){
	  if(strchr(line,'<')){
	    sscanf(line,"%*s %*s %*[<] %li %*[ .>] %li",
		   &ORF[q].start, &ORF[q].stop);
	  }
	  else{
	    sscanf(line,"%*s %*s %li %*[ .>] %li",
		   &ORF[q].start, &ORF[q].stop);
	  }
	  q++;
	}
	free(line);
	line=get_line(fp);
	continue;
      }
      if(!strncmp(line,"     exon",9)){
	if(strchr(line,'<')){
	  sscanf(line,"%*s %*[<] %li %*[ .>] %li",
		 &exon[w].start, &exon[w].stop);
	}
	else{
	  sscanf(line,"%*s %li %*[ .>] %li",
		 &exon[w].start, &exon[w].stop);
	}
	w++;
	ex=1;
	free(line);
	line=get_line(fp);
	continue;
      }
      if(!strncmp(line,"FT   exon",9)){
	if(strchr(line,'<')){
	  sscanf(line,"%*s %*s %*[<] %li %*[ .>] %li",
		 &exon[w].start, &exon[w].stop);
	}
	else{
	  sscanf(line,"%*s %*s %li %*[ .>] %li",
		 &exon[w].start, &exon[w].stop);
	}
	w++;
	ex=1;
	free(line);
	line=get_line(fp);
	continue;
      }
      else {
	line=get_line(fp);
	continue;
      }
    }
    if(ex){
      aa=0;
      exon[aa].join=1;
      aa++;
      while(exon[aa+1].start){
	exon[aa].join=2;
	aa++;
      }
      exon[aa].join=3;
      exon[aa].AAseq = (char*)space(60000*sizeof(char));
      strcpy(exon[aa].AAseq, exon[0].AAseq);
      free(exon[0].AAseq);
    }
    ok=write2SEQ1(FN, CTN, seqname, seq, len, ORF, exon);
    free(seq); 
    q=0;
    w=0;
    line=get_line(fp);
  }
  if(is_fp)  fclose(fp);
  return(ok);
}

/*--------------------------------------------------------------------------*/

char *readAAseq(char *line, FILE *fp, short is_fp){
  
  int l, n, m, i, j, k=0, a=0, b;
  char *aaseq;
  
  n=strlen(line);
  l=0;
  for (i=35; i<n; i++){
    if(isalpha(line[i]))   l++;
  }
  aaseq = (char*)space((l+1)*sizeof(char));
  for (i=35; i<n; i++){
    if(isalpha(line[i])){
      aaseq[k] = toupper(line[i]);
      k++;
    }
  }
  line = get_line(fp);
  while(line){
    if(!strncmp(line, "FT  ", 4)){
      sscanf(line, "%*s %s", line);
    }
    m=0;
    for(b=0; b<strlen(line); b++){
      if(isalpha(line[b])) m++;
    }
    l=l+m;
    aaseq=(char*)realloc(aaseq,(l+1)*sizeof(char));
    for (j=0; j<strlen(line); j++){
      if(isalpha(line[j])){
	aaseq[k] = toupper(line[j]);
	k++;
	continue;
      }
      else{
	if(strchr(line,'"')!=0)	a=1;
      }
    }
    if(a) break;
    else{
      free(line);
      line = get_line(fp);
    }
  }
  aaseq[k]='\0';
  return aaseq;
}

/*-----------------------------------------------------------------------------*/

void mergeJOIN(){

  short a=0, b=0, c, d=0;
  char *joinseq=NULL;
  long joinlen, newlen;
  
  while(SEQ[a].seq){
    while(SEQ[a].ORF[b].start){
      SEQ[a].ORF[b].joinedSeq=NULL;
      switch(SEQ[a].ORF[b].join){
      case 0: {
	break;
      }
      case 1: {
	joinseq=(char*)space((SEQ[a].ORF[b].stop -
			      SEQ[a].ORF[b].start + 2)*sizeof(char));
	for(c=(SEQ[a].ORF[b].start-1); c<(SEQ[a].ORF[b].stop); c++){
	  joinseq[d]=SEQ[a].seq[c];
	  d++;
	}
	joinseq[d]='\0';
	break;
      }
      case 2: {
	joinlen=strlen(joinseq);
	newlen=(SEQ[a].ORF[b].stop - SEQ[a].ORF[b].start +1);
	joinseq=(char*)realloc(joinseq, (joinlen+newlen+1)*sizeof(char));
	for(c=(SEQ[a].ORF[b].start-1); c<(SEQ[a].ORF[b].stop); c++){
	  joinseq[d]=SEQ[a].seq[c];
	  d++;
	}
	joinseq[d]='\0';
	break;
      }
      case 3: {
	joinlen=strlen(joinseq);
	newlen=(SEQ[a].ORF[b].stop - SEQ[a].ORF[b].start +1);
	joinseq=(char*)realloc(joinseq, (joinlen+newlen+1)*sizeof(char));
	for(c=(SEQ[a].ORF[b].start-1); c<(SEQ[a].ORF[b].stop); c++){
	  joinseq[d]=SEQ[a].seq[c];
	  d++;
	}
	joinseq[d]='\0';
	SEQ[a].ORF[b].joinedSeq=(char*)space((strlen(joinseq)+1)*sizeof(char));
	strcpy(SEQ[a].ORF[b].joinedSeq, joinseq);
	free(joinseq);
	d=0;
	break;
      }
      default: help(0);
      }
      b++;
    }

    b=0;
    d=0;
    while(SEQ[a].exon[b].start){
      SEQ[a].exon[b].joinedSeq=NULL;
      switch(SEQ[a].exon[b].join){
      case 0: {
	break;
      }
      case 1: {
	joinseq=(char*)space((SEQ[a].exon[b].stop -
			      SEQ[a].exon[b].start + 2)*sizeof(char));
	for(c=(SEQ[a].exon[b].start-1); c<(SEQ[a].exon[b].stop); c++){
	  joinseq[d]=SEQ[a].seq[c];
	  d++;
	}
	joinseq[d]='\0';
	break;
      }
      case 2: {
	joinlen=strlen(joinseq);
	newlen=(SEQ[a].exon[b].stop - SEQ[a].exon[b].start +1);
	joinseq=(char*)realloc(joinseq, (joinlen+newlen+1)*sizeof(char));
	for(c=(SEQ[a].exon[b].start-1); c<(SEQ[a].exon[b].stop); c++){
	  joinseq[d]=SEQ[a].seq[c];
	  d++;
	}
	joinseq[d]='\0';
	break;
      }
      case 3: {
	joinlen=strlen(joinseq);
	newlen=(SEQ[a].exon[b].stop - SEQ[a].exon[b].start +1);
	joinseq=(char*)realloc(joinseq, (joinlen+newlen+1)*sizeof(char));
	for(c=(SEQ[a].exon[b].start-1); c<(SEQ[a].exon[b].stop); c++){
	  joinseq[d]=SEQ[a].seq[c];
	  d++;
	}
	joinseq[d]='\0';
	SEQ[a].exon[b].joinedSeq=(char*)space
	  ((strlen(joinseq)+1)*sizeof(char));
	strcpy(SEQ[a].exon[b].joinedSeq, joinseq);
	free(joinseq);
	d=0;
	break;
      }
      default: help(0);
      }
      b++;
    }
    b=0;
    a++;
  }
}
